clang 10.0.0git

Public Types | Public Member Functions | Protected Member Functions | Friends | List of all members
clang::OMPVarListClause< T > Class Template Reference

This represents clauses with the list of variables like 'private', 'firstprivate', 'copyin', 'shared', or 'reduction' clauses in the '#pragma omp ...' directives. More...

`#include "clang/AST/OpenMPClause.h"`

Inheritance diagram for clang::OMPVarListClause< T >:
[legend]
Collaboration diagram for clang::OMPVarListClause< T >:
[legend]

## Public Types
using | varlist_iterator = MutableArrayRef< Expr * >::iterator
using | varlist_const_iterator = ArrayRef< const Expr * >::iterator
using | varlist_range = llvm::iterator_range< varlist_iterator >
using | varlist_const_range = llvm::iterator_range< varlist_const_iterator >
Public Types inherited from clang::OMPClause
using | child_iterator = StmtIterator
using | const_child_iterator = ConstStmtIterator
using | child_range = llvm::iterator_range< child_iterator >
using | const_child_range = llvm::iterator_range< const_child_iterator >

## Public Member Functions
unsigned | varlist_size () const
bool | varlist_empty () const
varlist_range | varlists ()
varlist_const_range | varlists () const
varlist_iterator | varlist_begin ()
varlist_iterator | varlist_end ()
varlist_const_iterator | varlist_begin () const
varlist_const_iterator | varlist_end () const
void | setLParenLoc (SourceLocation Loc)
| Sets the location of '('. More...
SourceLocation | getLParenLoc () const
| Returns the location of '('. More...
ArrayRef< const Expr * > | getVarRefs () const
| Fetches list of all variables in the clause. More...
Public Member Functions inherited from clang::OMPClause
SourceLocation | getBeginLoc () const
| Returns the starting location of the clause. More...
SourceLocation | getEndLoc () const
| Returns the ending location of the clause. More...
void | setLocStart (SourceLocation Loc)
| Sets the starting location of the clause. More...
void | setLocEnd (SourceLocation Loc)
| Sets the ending location of the clause. More...
OpenMPClauseKind | getClauseKind () const
| Returns kind of OpenMP clause (private, shared, reduction, etc.). More...
bool | isImplicit () const
child_range | children ()
const_child_range | children () const
child_range | used_children ()
| Get the iterator range for the expressions used in the clauses. More...
const_child_range | used_children () const

## Protected Member Functions
| OMPVarListClause (OpenMPClauseKind K, SourceLocation StartLoc, SourceLocation LParenLoc, SourceLocation EndLoc, unsigned N)
| Build a clause with N variables. More...
MutableArrayRef< Expr * > | getVarRefs ()
| Fetches list of variables associated with this clause. More...
void | setVarRefs (ArrayRef< Expr *> VL)
| Sets the list of variables for this clause. More...
Protected Member Functions inherited from clang::OMPClause
| OMPClause (OpenMPClauseKind K, SourceLocation StartLoc, SourceLocation EndLoc)

## Friends
class | OMPClauseReader

## Additional Inherited Members
Static Public Member Functions inherited from clang::OMPClause
static bool | classof (const OMPClause *)

## Detailed Description

### template<class T>
class clang::OMPVarListClause< T >

This represents clauses with the list of variables like 'private', 'firstprivate', 'copyin', 'shared', or 'reduction' clauses in the '#pragma omp ...' directives.

Definition at line 188 of file OpenMPClause.h.

## Member Typedef Documentation

## ◆ varlist_const_iterator

template<class T>

using clang::OMPVarListClause< T >::varlist_const_iterator = ArrayRef<const Expr *>::iterator

Definition at line 225 of file OpenMPClause.h.

## ◆ varlist_const_range

template<class T>

using clang::OMPVarListClause< T >::varlist_const_range = llvm::iterator_range<varlist_const_iterator>

Definition at line 227 of file OpenMPClause.h.

## ◆ varlist_iterator

template<class T>

using clang::OMPVarListClause< T >::varlist_iterator = MutableArrayRef<Expr *>::iterator

Definition at line 224 of file OpenMPClause.h.

## ◆ varlist_range

template<class T>

using clang::OMPVarListClause< T >::varlist_range = llvm::iterator_range<varlist_iterator>

Definition at line 226 of file OpenMPClause.h.

## Constructor & Destructor Documentation

## ◆ OMPVarListClause()

template<class T>

clang::OMPVarListClause< T >::OMPVarListClause | ( | OpenMPClauseKind | K,
|  | SourceLocation | StartLoc,
|  | SourceLocation | LParenLoc,
|  | SourceLocation | EndLoc,
|  | unsigned | N
| ) |  |
| inline protected

Build a clause with N variables.

Parameters

  K | Kind of the clause.
  StartLoc | Starting location of the clause (the clause keyword).
  LParenLoc | Location of '('.
  EndLoc | Ending location of the clause.
  N | Number of the variables in the clause.

Definition at line 205 of file OpenMPClause.h.

## Member Function Documentation

## ◆ getLParenLoc()

template<class T>

SourceLocation clang::OMPVarListClause< T >::getLParenLoc | ( |  | ) | const
| inline

Returns the location of '('.

Definition at line 248 of file OpenMPClause.h.

Referenced by clang::TreeTransform< Derived >::TransformOMPExecutableDirective(), and clang::ASTRecordWriter::writeOMPClause().

## ◆ getVarRefs() [1/2]

template<class T>

MutableArrayRef<Expr *> clang::OMPVarListClause< T >::getVarRefs | ( |  | ) |
| inline protected

Fetches list of variables associated with this clause.

Definition at line 210 of file OpenMPClause.h.

## ◆ getVarRefs() [2/2]

template<class T>

ArrayRef<const Expr *> clang::OMPVarListClause< T >::getVarRefs | ( |  | ) | const
| inline

Fetches list of all variables in the clause.

Definition at line 251 of file OpenMPClause.h.

## ◆ setLParenLoc()

template<class T>

void clang::OMPVarListClause< T >::setLParenLoc | ( | SourceLocation | Loc | ) |
| inline

Sets the location of '('.

Definition at line 245 of file OpenMPClause.h.

Referenced by clang::OMPClauseReader::VisitOMPClauseWithPostUpdate().

## ◆ setVarRefs()

template<class T>

void clang::OMPVarListClause< T >::setVarRefs | ( | ArrayRef< Expr *> | VL | ) |
| inline protected

Sets the list of variables for this clause.

Definition at line 216 of file OpenMPClause.h.

Referenced by clang::OMPPrivateClause::Create(), clang::OMPFirstprivateClause::Create(), clang::OMPLastprivateClause::Create(), clang::OMPSharedClause::Create(), clang::OMPReductionClause::Create(), clang::OMPTaskReductionClause::Create(), clang::OMPInReductionClause::Create(), clang::OMPSharedClause::CreateEmpty(), and clang::OMPClauseReader::VisitOMPClauseWithPostUpdate().

## ◆ varlist_begin() [1/2]

template<class T>

varlist_iterator clang::OMPVarListClause< T >::varlist_begin | ( |  | ) |
| inline

Definition at line 239 of file OpenMPClause.h.

## ◆ varlist_begin() [2/2]

template<class T>

varlist_const_iterator clang::OMPVarListClause< T >::varlist_begin | ( |  | ) | const
| inline

Definition at line 241 of file OpenMPClause.h.

## ◆ varlist_empty()

template<class T>

bool clang::OMPVarListClause< T >::varlist_empty | ( |  | ) | const
| inline

Definition at line 230 of file OpenMPClause.h.

Referenced by OMPNontemporalClause::setPrivateRefs().

## ◆ varlist_end() [1/2]

template<class T>

varlist_iterator clang::OMPVarListClause< T >::varlist_end | ( |  | ) |
| inline

Definition at line 240 of file OpenMPClause.h.

## ◆ varlist_end() [2/2]

template<class T>

varlist_const_iterator clang::OMPVarListClause< T >::varlist_end | ( |  | ) | const
| inline

Definition at line 242 of file OpenMPClause.h.

## ◆ varlist_size()

template<class T>

unsigned clang::OMPVarListClause< T >::varlist_size | ( |  | ) | const
| inline

Definition at line 229 of file OpenMPClause.h.

Referenced by FinishOpenMPLinearClause(), OMPMappableExprListClause< OMPIsDevicePtrClause >::getUDMapperRefs(), OMPMappableExprListClause< OMPIsDevicePtrClause >::setUDMapperRefs(), clang::TreeTransform< Derived >::TransformOMPExecutableDirective(), clang::OMPClauseReader::VisitOMPClauseWithPostUpdate(), and clang::ASTRecordWriter::writeOMPClause().

## ◆ varlists() [1/2]

template<class T>

varlist_range clang::OMPVarListClause< T >::varlists | ( |  | ) |
| inline

Definition at line 232 of file OpenMPClause.h.

Referenced by FinishOpenMPLinearClause(), clang::TreeTransform< Derived >::TransformOMPExecutableDirective(), and clang::ASTRecordWriter::writeOMPClause().

## ◆ varlists() [2/2]

template<class T>

varlist_const_range clang::OMPVarListClause< T >::varlists | ( |  | ) | const
| inline

Definition at line 235 of file OpenMPClause.h.

## Friends And Related Function Documentation

## ◆ OMPClauseReader

template<class T>

friend class OMPClauseReader
| friend

Definition at line 189 of file OpenMPClause.h.

The documentation for this class was generated from the following file:

- include/clang/AST/OpenMPClause.h